



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Humming Bird A20 SPI2驱动编译</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Humming Bird A20 SPI2驱动编译</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 21:03:35 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>Humming Bird A20 SPI2使用编译</p>
<p>Yao.GUET 2014-07-17,请注明出处：<a href="http://blog.csdn.net/Yao_GUET" rel="external nofollow noreferrer">http://blog.csdn.net/Yao_GUET</a></p>
<p>A20上带有4个spi接口，因为Humming Bird A20仅仅引出了SPI2，所以这里就以spi2为例。看一下fex文件是怎么设置的。</p>
<p>因为我拿到的linux内核上是已经有spi-sun7i的驱动代码文件。的民民主的所以没有代码的同鞋自己去下载patch包吧。</p>
<p>依据linux-sunxi中spi使用的文档，须要改动kernel的编译配置：</p>
<p>CONFIG_SPI_SUN4I=y<br /><br />
CONFIG_SPI=y<br /><br />
CONFIG_SPI_MASTER=y<br /><br />
CONFIG_EXPERIMENTAL=y<br /><br />
CONFIG_SPI_SPIDEV=y</p>
<p>做完这一步之后，还须要改动fex文件。因为我用的是android的系统。所以，配置文件位置例如以下：</p>
<p>a20_hummingbird_v3.0_v4/lichee/tools/pack/chips/sun7i/configs/android/wing-k70/sys_config.fex</p>
<h1>&quot;spi2_para&quot;的配置：</h1>
<pre class="prettyprint linenums">[spi2_para]<br />
spi_used            = 1<br />
spi_cs_bitmap       = 1<br />
spi_cs0             = port:PB14&lt;2&gt;&lt;default&gt;&lt;default&gt;&lt;default&gt;<br />
spi_sclk            = port:PB15&lt;2&gt;&lt;default&gt;&lt;default&gt;&lt;default&gt;<br />
spi_mosi            = port:PB16&lt;2&gt;&lt;default&gt;&lt;default&gt;&lt;default&gt;<br />
spi_miso            = port:PB17&lt;2&gt;&lt;default&gt;&lt;default&gt;&lt;default&gt;</pre>
<p>当中：</p>
<p>spi_used： ＝1 表示使用，＝0则表示不使用；</p>
<p>spi_cs_bitmap：＝1表示片选使用spi2_cs0，＝2表示片选使用spi2_cs1，＝3表示片选使用spi2_cs0和spi2_cs1；</p>
<p>我这里使用的是PB14-PB17这一组spi2接口，尖括号中面的2代表的是复用功能的选择（SPI）。</p>
<h1>spi_devices设备数量设置</h1>
<pre class="prettyprint linenums">[spi_devices]<br />
spi_dev_num = 1</pre>
<p>spi_dev_num：代表使用的spi的总数量，这里我仅仅用了一个所以写1，这个须要跟后面“spi_board”这个一起使用。</p>
<p>比如我这里数量是1，那么我后面就要用到&quot;spi_board0&quot;。num＝3，那么后面须要有3个spi的配置“spi_board0”。“spi_board1”。“spi_board2”，每个相应一个spi接口。</p>
<p><h1>spi_board设置</h1>
<pre class="prettyprint linenums">[spi_board0]<br />
modalias = &quot;spidev&quot;<br />
max_speed_hz = 12000000<br />
bus_num = 2<br />
chip_select = 0<br />
mode = 0<br />
full_duplex = 0<br />
manual_cs = 0</pre>
<p>modalias：spi设备的名称</p>
<p>max_speed_hz：最大传输速度</p>
<p>bus_num：这个比較的重要。是这个spi_board所相应的spi的总线号，这里我使用的是spi2，所以“bus_num=2”<br /><br />
mode：这个主要是设置同步时间的极性与相位</p>
<table>
<tbody>
<tr>
<td>SPI MODE</td>
<td>CPOL</td>
<td>CPHA</td>
<td>採样边缘</td>
</tr>
<tr>
<td>0</td>
<td>0</td>
<td>0</td>
<td>上升沿</td>
</tr>
<tr>
<td>1</td>
<td>0</td>
<td>1</td>
<td>下降沿</td>
</tr>
<tr>
<td>2</td>
<td>1</td>
<td>0</td>
<td>下降沿</td>
</tr>
<tr>
<td>3</td>
<td>1</td>
<td>1</td>
<td>上升沿</td>
</tr>
</tbody>
</table>
<p>full_duplex和manual_cs这两个參数，在我手上的这一份spi-sun7i代码里面是没有读的。应该还没有支持，，，</p>
<p>有兴趣的同鞋也能够自己看一下spi-sun7i的代码。就在/linux/drivers/spi/spi-sun7i.c</p>
<p>编译好内核，再打包生成img文件，烧写启动系统，你会在/dev文件夹发现spidev2.0该装置，这说明，spi2你应该可以正常使用，，，</p>
<div>
<p>版权声明：本文博客原创文章。博客，未经同意，不得转载。</p></p></div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m9601r49.html">PHP JSON数组与对象的理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gpg779.html">大数据系列（2）&mdash;&mdash;Hadoop集群坏境CentOS安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq156p49.html">&lpar;转）Mybatis高级映射、动态SQL及获得自增主键</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql52we8.html">Install Atom editor in ubuntu 14&period;04</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m4v4r8.html">Unity NGUI  资源下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2zldwq.html">css之字体设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xxyjn9.html">FineReport&colon; 参数为空选出全部值&lpar;按条件查询，空条件时直接过滤，不进行查询。。&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1jvzr9.html">C&num; Winform中WndProc 函数作用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd532r8.html">PostgreSQL的AnynonArray的例子</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdrve38.html">phpcms v9</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1p0519.html">C&num; mvc 验证码3</a>
		</li>
						<li><a href="https://www.batexi.com/a/950ynje8.html">VM安装Ubuntu问题合集（无法联网、中文界面设置、中文输入法etc）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpg1xr9.html">Cannot start service MSSQL&dollar;MICROSOFT&num;&num;WID on computer</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gelpjl8.html">h5-音视频标签</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p65gn8.html">c&plus;&plus;第七周学习小结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjxd6l9.html">&lbrack;PHP&rsqb;算法-替换空格的PHP实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gvmnmq.html">Idea默认的全局设置，如Maven等</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1ro149.html">Spring整合strus2简单应用总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyz3zv9.html">PHP数组排序函数有哪些</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv7e3x8.html">redis-storage介绍&lbrack;转&rsqb;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8kpp4lj9.html">开源 自由 java CMS - FreeCMS2&period;0 举APP产生信息数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpplv7q.html">A &equals;&equals; B &quest;（杭州电2054）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojjo0pq.html">etl工具，kettle实现了周期</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zzw0j9.html">Following unknown configure options were used&colon;--enable-fpm</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojjwneq.html">A星寻路lua实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yylyz8.html">jquery php 百度搜索框智能提示效果</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojjwplq.html">android 原生应用、Web应用、混合应用优缺点分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdppvwjq.html">MEF初体验之六：导出和元素据</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mee4jpq.html">nodejs 模拟form表单上传文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljj3e19.html">最大流量dinci模板</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
